'
' ####################
' #####  PROLOG  #####
' ####################
'
' Download 10 urls simultaneously using curl_multi_perform() and curl_multi_info_read()
'
PROGRAM	"10atatime"
VERSION	"0.0001"
CONSOLE
'
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT  "xsx"
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT 	"libcurl"		' CURL library

TYPE URL_DATA
	STRING * 256 .url
	STRING * 256 .file
END TYPE

TYPE URL_COMPONENTS
	XLONG	.dwStructSize
	XLONG	.lpszScheme
	XLONG	.dwSchemeLength
	XLONG	.nScheme
	XLONG	.lpszHostName
	XLONG	.dwHostNameLength
	XLONG	.nPort
	XLONG	.lpszUserName
	XLONG	.dwUserNameLength
	XLONG	.lpszPassword
	XLONG	.dwPasswordLength
	XLONG	.lpszUrlPath
	XLONG	.dwUrlPathLength
	XLONG	.lpszExtraInfo
	XLONG	.dwExtraInfoLength
END TYPE

$$MAX_PARALLEL = 10 ' number of simultaneous transfers
$$NUM_URLS = 47

$$ICU_ESCAPE 							= 0x80000000  '(un)escape URL characters
$$ICU_USERNAME 						= 0x40000000  'use internal username &amp; password
$$ICU_NO_ENCODE 					= 0x20000000 	'Don't convert unsafe characters to escape sequence
$$ICU_DECODE 							= 0x10000000 	'Convert %XX escape sequences to characters
$$ICU_NO_META 						= 0x8000000 	'Don't convert .. etc. meta path sequences
$$ICU_ENCODE_SPACES_ONLY 	= 0x4000000 	'Encode spaces only
$$ICU_BROWSER_MODE 				= 0x2000000 	'Special encode/decode rules for browser
$$ICU_ENCODE_PERCENT 			= 0x1000 			'Encode any percent (ASCII25)

$$INTERNET_SCHEME_PARTIAL 		= -2
$$INTERNET_SCHEME_UNKNOWN 		= -1
$$INTERNET_SCHEME_DEFAULT 		= 0
$$INTERNET_SCHEME_FTP 				= 1
$$INTERNET_SCHEME_GOPHER 			= 2
$$INTERNET_SCHEME_HTTP 				= 3
$$INTERNET_SCHEME_HTTPS 			= 4
$$INTERNET_SCHEME_FILE 				= 5
$$INTERNET_SCHEME_NEWS 				= 6
$$INTERNET_SCHEME_MAILTO 			= 7
$$INTERNET_SCHEME_SOCKS 			= 8
$$INTERNET_SCHEME_JAVASCRIPT 	= 9
$$INTERNET_SCHEME_VBSCRIPT 		= 10
$$INTERNET_SCHEME_FIRST 			= 1
$$INTERNET_SCHEME_LAST 				= 10

'
DECLARE FUNCTION Entry ()
DECLARE CFUNCTION  WriteData (bufAddr, elemSize, numElem, fileNumber)
DECLARE FUNCTION InitUrls ()
DECLARE FUNCTION CurlMultiDownload (@url$[])
DECLARE FUNCTION AddTransfer (curlm, @url$, @filename$, id)
DECLARE FUNCTION CrackURL (url$, @scheme$, @hostName$, @userName$, @password$, @urlPath$, @extraInfo$)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

SHARED urls$[]

	InitUrls ()
	CurlMultiDownload (@urls$[])

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION InitUrls ()

SHARED urls$[]

DATA "https://www.microsoft.com/en-us/", "https://opensource.org"
DATA "https://www.google.com", "https://www.yahoo.com"
DATA "https://www.ibm.com/us-en/", "https://www.mysql.com"
DATA "https://www.oracle.com/index.html", "https://newatlas.com/"
DATA "https://www.iana.org", "https://www.amazon.com"
DATA "https://www.netcraft.com", "https://www.heise.de"
DATA "https://www.chip.de", "https://www.upi.com/"
DATA "https://www.cnet.com", "https://www.mozilla.org/en-US/"
DATA "https://www.cnn.com", "https://www.wikipedia.org"
DATA "https://boingboing.net/", "https://www8.hp.com/us/en/home.html"
DATA "https://www.sei.cmu.edu/", "https://www.mit.edu"
DATA "https://www.nist.gov", "https://www.ebay.com"
DATA "https://www.playstation.com/en-us/", "https://www.uefa.com"
DATA "https://www.ieee.org", "https://www.apple.com"
DATA "https://www.symantec.com", "https://www.zdnet.com"
DATA "https://www.fujitsu.com/global/", "https://www.supermicro.com/en"
DATA "https://www.sciencedaily.com/", "https://www.ietf.org"
DATA "https://www.bbc.co.uk", "https://www.reuters.com"
DATA "https://www.foxnews.com", "https://www.msn.com"
DATA "https://www.wired.com", "https://www.sky.com"
DATA "https://www.usatoday.com", "https://www.cbs.com"
DATA "https://www.nbc.com/", "https://slashdot.org"
DATA "https://www.informationweek.com", "https://apache.org"
DATA "https://www.un.org"

	DIM urls$[46]
	upp = UBOUND (urls$[])
	
	FOR i = 0 TO upp
		READ a$
		urls$[i] = a$
	NEXT i

END FUNCTION

'
'
' ##########################
' #####  WriteData ()  #####
' ##########################
'
CFUNCTION  WriteData (bufAddr, elemSize, numElem, fileNumber)

'	PRINT bufAddr, elemSize, numElem, fileNumber
'RETURN
	size = elemSize * numElem
	data$ = NULL$ (size)
	RtlMoveMemory (&data$, bufAddr, size)

	' append file
	SEEK (fileNumber, LOF (fileNumber))
	WRITE [fileNumber], data$

	RETURN size

END FUNCTION
'
' ###############################
' #####  CurlMultiDownload  #####
' ###############################
'
'
'
FUNCTION CurlMultiDownload (@url$[])

  CURLMSG msg
  msgs_left = -1
  still_alive = 1
	
	upp = UBOUND (url$[])

  curl_global_init($$CURL_GLOBAL_ALL)
  cm = curl_multi_init()

  ' Limit the amount of simultaneous connections curl should allow: 
  ret = curl_multi_setopt (cm, $$CURLMOPT_MAXCONNECTS, $$MAX_PARALLEL)
	
	ub = $$MAX_PARALLEL-1
	IF upp < $$MAX_PARALLEL-1 THEN ub = upp

  FOR i = 0 TO ub
		u$ = url$[i]
		CrackURL (u$, @scheme$, @hostName$, @userName$, @password$, @urlPath$, @extraInfo$)
		fn$ = hostName$
		count = XstReplace (@fn$, ".", "_", 0) 
		fn$ = fn$ + ".html"
? fn$, ".....", u$
    AddTransfer (cm, @u$, @fn$, i)
	NEXT i

  DO 
    curl_multi_perform (cm, &still_alive)
'		? "curl_multi_perform::still_alive= "; still_alive
    DO 
			pM = curl_multi_info_read (cm, &msgs_left)
			
			IF pM THEN
				XstCopyMemory (pM, &msg, SIZE(msg)) 
			ELSE
				EXIT DO
			END IF

      IF (msg.msg == $$CURLMSG_DONE) THEN 
        eh = msg.easy_handle
        curl_easy_getinfo (eh, $$CURLINFO_PRIVATE, &ofile)
				'PRINT "$$CURLMSG_DONE", "msg.easy_handle=";msg.easy_handle, "id="; id
        PRINT "Result: "; CSTRING$ (curl_easy_strerror(msg.result)), " File size: "; LOF (ofile); " bytes."
        curl_multi_remove_handle (cm, eh)
        curl_easy_cleanup (eh)
'				PRINT "File size :"; LOF (ofile); " bytes."
				CLOSE (ofile)														' close the data file
      ELSE 
        PRINT "Error: CURLMsg", msg.msg
      END IF 
      IF (i <= upp) THEN 
'				INC i
				u$ = url$[i]
				CrackURL (u$, @scheme$, @hostName$, @userName$, @password$, @urlPath$, @extraInfo$)
				fn$ = hostName$
				count = XstReplace (@fn$, ".", "_", 0) 
				fn$ = fn$ + ".html"
? fn$, ".....", u$
        AddTransfer (cm, @u$, fn$, i)
				INC i
			END IF 
    LOOP
		 
    IF (still_alive) THEN 
      curl_multi_wait (cm, NULL, 0, 1000, NULL)
		END IF 

  LOOP WHILE (still_alive || (i < upp))
end:
  curl_multi_cleanup (cm)
  curl_global_cleanup()

  RETURN 

END FUNCTION

FUNCTION AddTransfer (curlm, @url$, @filename$, id)

	ofile = OPEN (filename$, $$RWNEW)	

	IF (ofile < 3) THEN
		PRINT "File OPEN error"
		RETURN ($$TRUE)
	END IF
'? "AddTransfer::filename$: "; filename$, "ofile: "; ofile

	useragent$ = "Mozilla/5.0 (Windows NT 10.0; rv:72.0) Gecko/20100101 Firefox/72.0"

  eh = curl_easy_init ()
  curl_easy_setopt (eh, $$CURLOPT_WRITEFUNCTION, &WriteData())
  curl_easy_setopt (eh, $$CURLOPT_URL, &url$)
	curl_easy_setopt (eh, $$CURLOPT_WRITEDATA, ofile)	' we want to write the data to this file handle
  curl_easy_setopt (eh, $$CURLOPT_PRIVATE, ofile)   ' save the file handle so it can be closed when download is finished
	curl_easy_setopt (eh, $$CURLOPT_SSL_VERIFYPEER, 0) ' do not verify ssl certificate
	curl_easy_setopt (eh, $$CURLOPT_USERAGENT, &useragent$) ' add user agent string
'	curl_easy_setopt (eh, $$CURLOPT_NOPROGRESS, 1)	  ' no progress meter please
  curl_multi_add_handle (curlm, eh)
	
END FUNCTION

'
'
' #########################
' #####  CrackURL ()  #####
' #########################
'
' Break url$ into component parts.
'
FUNCTION  CrackURL (url$, @scheme$, @hostName$, @userName$, @password$, @urlPath$, @extraInfo$)

	STATIC entry, initOK
	SHARED hWininet
	STATIC FUNCADDR CanonicalizeUrl (XLONG, XLONG, XLONG, XLONG)
	STATIC FUNCADDR CrackUrl (XLONG, XLONG, XLONG, XLONG)
	URL_COMPONENTS cmp

	$BUFSIZE = 1024

	IFZ url$ THEN RETURN ($$TRUE)
	IFZ entry THEN GOSUB Initialize
	IF initOK THEN GOSUB ErrorFound

' try to insure a valid URL to begin with

	buffer$ = NULL$ ($BUFSIZE)
	bufLen = LEN (buffer$)
	IF @CanonicalizeUrl (&url$, &buffer$, &bufLen, $$ICU_BROWSER_MODE) THEN
		url$ = LEFT$ (buffer$, bufLen)

' reset structure and supply buffers

		scheme$ 		= buffer$
		hostName$ 	= buffer$
		userName$ 	= buffer$
		password$ 	= buffer$
		urlPath$ 		= buffer$
		extraInfo$ 	= buffer$
'
		cmp.dwStructSize 			= SIZE (cmp)
		cmp.lpszScheme 				= &scheme$
		cmp.dwSchemeLength 		= $BUFSIZE
		cmp.nScheme 					= $$INTERNET_SCHEME_UNKNOWN
		cmp.lpszHostName 			= &hostName$
		cmp.dwHostNameLength 	= $BUFSIZE
		cmp.nPort 						= 0
		cmp.lpszUserName 			= &userName$
		cmp.dwUserNameLength 	= $BUFSIZE
		cmp.lpszPassword 			= &password$
		cmp.dwPasswordLength 	= $BUFSIZE
		cmp.lpszUrlPath 			= &urlPath$
		cmp.dwUrlPathLength 	= $BUFSIZE
		cmp.lpszExtraInfo 		= &extraInfo$
		cmp.dwExtraInfoLength = $BUFSIZE
'
' crack URL apart and get what we can from it
'
		ret = @CrackUrl (&url$, LEN (url$), $$ICU_ESCAPE, &cmp)

' get results
'
		scheme$ 		= CSIZE$ (scheme$)
		hostName$ 	= CSIZE$ (hostName$)
		userName$ 	= CSIZE$ (userName$)
		password$ 	= CSIZE$ (password$)
		urlPath$ 		= CSIZE$ (urlPath$)
		extraInfo$ 	= CSIZE$ (extraInfo$)

	ELSE
		ret = $$TRUE
	END IF

	RETURN ret

' ***** Initialize *****
SUB Initialize

	entry = $$TRUE

	hWininet = LoadLibraryA (&"wininet.dll")
	IFZ hWininet THEN
		PRINT "Error : LoadLibraryA() : wininet.dll"
		GOSUB ErrorFound
	END IF

	CanonicalizeUrl = GetProcAddress (hWininet, &"InternetCanonicalizeUrlA")
	IFZ CanonicalizeUrl THEN GOSUB ErrorFound

	CrackUrl = GetProcAddress (hWininet, &"InternetCrackUrlA")
	IFZ CrackUrl THEN GOSUB ErrorFound

END SUB

' ***** ErrorFound *****
SUB ErrorFound
	initOK = $$TRUE
 	RETURN $$TRUE
END SUB

END FUNCTION

END PROGRAM