'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo using libcurl.dll functions to download
' several URLs to local files using a persistant
' connection.
' ---
'	Libcurl is a free and easy-to-use client-side
' URL transfer library, supporting
' FTP, FTPS, HTTP, HTTPS, GOPHER, TELNET,
' DICT, FILE and LDAP.
' ---
' See CURL:
' https://curl.se
'
PROGRAM	"persistant"
VERSION	"0.0001"
CONSOLE
'
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT 	"libcurl"		' CURL library
'
DECLARE FUNCTION  Entry ()
DECLARE CFUNCTION  WriteData (bufAddr, elemSize, numElem, fileNumber)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
'
FUNCTION  Entry ()

	curl_global_init ($$CURL_GLOBAL_WIN32)		' initialize CURL library
	start = GetTickCount ()
 	curl_handle = curl_easy_init ()						'  init the curl session

	IFZ curl_handle THEN
		PRINT "curl_easy_init Error"
		a$ = INLINE$ ("Press ENTER to exit >")
		RETURN
	END IF

' set options

	curl_easy_setopt (curl_handle, $$CURLOPT_VERBOSE, 1)
	curl_easy_setopt (curl_handle, $$CURLOPT_HEADER, 1)
	curl_easy_setopt (curl_handle, $$CURLOPT_SSL_VERIFYPEER, 0)
	curl_easy_setopt (curl_handle, $$CURLOPT_WRITEFUNCTION, &WriteData()) ' send all data to this function

	url$ = "https://curl.se/"
	file$ = "index.html"
	GOSUB PullOneUrl

	url$ = "https://curl.se/news.html"
	file$ = "news.html"
	GOSUB PullOneUrl

	url$ = "https://raw.githubusercontent.com/curl/curl/master/docs/examples/persistent.c"
	file$ = "persistent.c"
	GOSUB PullOneUrl

	url$ = "https://curl.se/libcurl/c/example.html"
	file$ = "example.html"
	GOSUB PullOneUrl

	curl_easy_cleanup (curl_handle)					'	cleanup curl stuff

	finish = GetTickCount() - start
	PRINT
	PRINT "Elapsed time ="; finish; " msec"
	PRINT

	curl_global_cleanup ()								' clean up CURL library

	a$ = INLINE$ ("Press ENTER to exit >")

' ***** PullOneUrl *****
SUB PullOneUrl
	curl_easy_setopt (curl_handle, $$CURLOPT_URL, &url$)		' set URL to get

 	ofile = OPEN (file$, $$RW)							' open the file to write data
 	IF (ofile < 3) THEN
		PRINT "File OPEN error"
		curl_easy_cleanup (curl_handle)
		EXIT SUB
	END IF

 	curl_easy_setopt (curl_handle, $$CURLOPT_WRITEDATA, ofile)	' we want the data to this file handle
	curl_easy_perform (curl_handle) 				' get the file

	PRINT "Download done."
	PRINT "File size :"; LOF (ofile); " bytes."
	CLOSE (ofile)														' close the data file
END SUB

END FUNCTION
'
'
' ##########################
' #####  WriteData ()  #####
' ##########################
'
CFUNCTION  WriteData (bufAddr, elemSize, numElem, fileNumber)

'	PRINT bufAddr, elemSize, numElem, fileNumber

	size = elemSize * numElem
	data$ = NULL$ (size)
'	XstCopyMemory (bufAddr, &data$, size)

	RtlMoveMemory (&data$, bufAddr, size)

	' append file
	SEEK (fileNumber, LOF (fileNumber))
	WRITE [fileNumber], data$

	RETURN size

END FUNCTION
END PROGRAM
