'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo using libcurl.dll functions to download
' a URL to a local file.
'	Libcurl is a free and easy-to-use client-side
' URL transfer library, supporting
' FTP, FTPS, HTTP, HTTPS, GOPHER, TELNET,
' DICT, FILE and LDAP.
' ---
' See CURL:
' http://curl.haxx.se/libcurl/
'
PROGRAM	"writefile"
VERSION	"0.0001"
CONSOLE
'
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT 	"libcurl"		' CURL library
'
DECLARE FUNCTION  Entry ()
DECLARE CFUNCTION  WriteData (bufAddr, elemSize, numElem, fileNumber)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
'
FUNCTION  Entry ()

	curl_global_init ($$CURL_GLOBAL_WIN32)		' initialize CURL library
 	curl_handle = curl_easy_init ()						'  init the curl session

	PRINT "curl_handle="; curl_handle

	IFZ curl_handle THEN
		PRINT "curl_easy_init Error"
		a$ = INLINE$ ("Press ENTER to exit >")
		RETURN
	END IF

	url$ = "https://www.usatoday.com"		' download an html url
	file$ = "usatoday.htm"

	curl_easy_setopt (curl_handle, $$CURLOPT_URL, &url$)		' set URL to get
	curl_easy_setopt (curl_handle, $$CURLOPT_NOPROGRESS, 1)	' no progress meter please
	curl_easy_setopt (curl_handle, $$CURLOPT_MUTE, 1)				' shut up completely
	curl_easy_setopt (curl_handle, $$CURLOPT_WRITEFUNCTION, &WriteData()) ' send all data to this FUNCTION
	curl_easy_setopt (curl_handle, $$CURLOPT_SSL_VERIFYPEER, 0) ' do not verify ssl certificate

 	ofile = OPEN (file$, $$RWNEW)							' open the file to write data
 	IF (ofile < 3) THEN
		PRINT "File OPEN error"
		curl_easy_cleanup (curl_handle)
		a$ = INLINE$ ("Press ENTER to exit >")
		RETURN ($$TRUE)
	END IF

 	ret = curl_easy_setopt (curl_handle, $$CURLOPT_WRITEDATA, ofile)	' we want the data to this file handle
	PRINT "curl_easy_setop() ret = "; ret
	ret = curl_easy_perform (curl_handle) 				' get the file
	PRINT "curl_easy_perform() ret = "; ret
	PRINT "Download done."
	PRINT "File size :"; LOF (ofile); " bytes."
	CLOSE (ofile)														' close the data file

	curl_easy_cleanup (curl_handle)					'	clean up curl stuff
	curl_global_cleanup ()									' clean up CURL library

	a$ = INLINE$ ("Press ENTER to exit >")

END FUNCTION
'
'
' ##########################
' #####  WriteData ()  #####
' ##########################
'
CFUNCTION  WriteData (bufAddr, elemSize, numElem, fileNumber)

'	PRINT bufAddr, elemSize, numElem, fileNumber

	size = elemSize * numElem
	data$ = NULL$ (size)
	RtlMoveMemory (&data$, bufAddr, size)

	' append file
	SEEK (fileNumber, LOF (fileNumber))
	WRITE [fileNumber], data$

	RETURN size

END FUNCTION
END PROGRAM
